﻿# -*- coding: utf-8 -*-
# Yonn1981 https://github.com/Yonn1981/Repo

import re

import requests
from Plugins.Extensions.IPTVPlayer.compat import urllib_quote
from Plugins.Extensions.IPTVPlayer.libs.matrix.hosters.hoster import iHoster
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.comaddon import VSlog

UA = 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.108 Mobile Safari/537.36'


class cHoster(iHoster):

    def __init__(self):
        iHoster.__init__(self, 'hexupload', 'Hexupload')

    def _getMediaLinkForGuest(self):
        VSlog(self._url)
        api_call = ''
        headers = {
            'User-Agent': UA
        }

        if 'embed' in self._url:
            d = re.findall('https://(.*?)/embed-([^<]+).html', self._url)
            for aEntry in d:
                sHost = aEntry[0]
                file_id = aEntry[1]

        else:
            d = re.findall('https://(.*?)/([^<]+)', self._url)
            for aEntry in d:
                sHost = aEntry[0]
                file_id = aEntry[1]
                if '/' in file_id:
                    file_id = file_id.split('/')[0]

        payload = {
            "op": "download3",
            "id": f"{file_id}",
            "ajax": "1",
            "method_free": "1"
        }
        headers['content-type'] = "application/x-www-form-urlencoded"
        headers['Accept'] = "application/json"
        sContent = requests.post(f'https://{sHost}/download', data=payload, headers=headers).json()
        api_call = sContent['result']['url']

        if api_call:
            return True, urllib_quote(api_call, ':/?=&')

        return False, False
