﻿# -*- coding: utf-8 -*-
# Yonn1981 https://github.com/Yonn1981/Repo

import base64
import time

from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.comaddon import siteManager
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.gui.gui import cGui
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.gui.hoster import cHosterGui
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.inputParameterHandler import \
    cInputParameterHandler
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.outputParameterHandler import \
    cOutputParameterHandler
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.requestHandler import \
    cRequestHandler
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.parser import cParser

SITE_IDENTIFIER = 'matam'
SITE_NAME = 'Matam TV'
SITE_DESC = 'arabic vod'

URL_MAIN = siteManager().getUrlMain(SITE_IDENTIFIER)

ISLAM_SHOWS = (URL_MAIN, 'showSeries')


def load():
    oGui = cGui()
    oOutputParameterHandler = cOutputParameterHandler()

    oOutputParameterHandler.addParameter('siteUrl', ISLAM_SHOWS[0])
    oGui.addDir(SITE_IDENTIFIER, 'showSeries', 'دروس و محاضرات', 'brmg.png', oOutputParameterHandler)

    oGui.setEndOfDirectory()


def showSeries():
    oGui = cGui()
    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')

    current_time = time.time()
    current_time_milliseconds = int(current_time * 1000)
    new_timestamp = current_time_milliseconds + 1000 * 1000

    oRequestHandler = cRequestHandler(f'{sUrl}json.php?page=json-all-channels&_={new_timestamp}')

    data = oRequestHandler.request(jsonDecode=True)
    oOutputParameterHandler = cOutputParameterHandler()
    filtered_channels = [channel for channel in data["data"] if channel['ls'] == '1']
    filtered_channels.extend([channel for channel in data["data"] if channel['ls'] != '1'])
    for channel in filtered_channels:

        siteUrl = f'{URL_MAIN}{channel["cn"]}'
        sTitle = base64.b64decode(channel["ct"]).decode("utf-8")
        if channel['ls'] == '1':
            sTitle = f'[COLOR red]مباشر - [/COLOR]{sTitle}'
        sDesc = base64.b64decode(channel["lt"]).decode("utf-8")
        sThumb = ''

        oOutputParameterHandler.addParameter('siteUrl', siteUrl)
        oOutputParameterHandler.addParameter('sMovieTitle', sTitle)
        oOutputParameterHandler.addParameter('sThumb', sThumb)
        oOutputParameterHandler.addParameter('sDesc', sDesc)

        oGui.addMisc(SITE_IDENTIFIER, 'showLinks', sTitle, 'sites/matam.png', '', sDesc, oOutputParameterHandler)

    oGui.setEndOfDirectory()


def showLinks():
    oGui = cGui()

    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')
    sMovieTitle = oInputParameterHandler.getValue('sMovieTitle')
    sThumb = oInputParameterHandler.getValue('sThumb')

    oParser = cParser()
    oRequestHandler = cRequestHandler(sUrl)
    sHtmlContent = oRequestHandler.request()

    sPattern = "yt_vid = '([^']+)"
    aResult = oParser.parse(sHtmlContent, sPattern)
    if aResult[0]:
        for aEntry in aResult[1]:
            sHosterUrl = f"https://www.youtube.com/embed/{aEntry}"

            if (oHoster := cHosterGui().checkHoster(sHosterUrl)):
                oHoster.setDisplayName(sMovieTitle)
                oHoster.setFileName(sMovieTitle)
                cHosterGui().showHoster(oGui, oHoster, sHosterUrl, sThumb)

    oGui.setEndOfDirectory()
