﻿# -*- coding: utf-8 -*-
# Yonn1981 https://github.com/Yonn1981/Repo

import base64
import re

from Plugins.Extensions.IPTVPlayer.compat import urlparse
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.comaddon import (
    VSlog, addon, siteManager)
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.gui.gui import cGui
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.gui.hoster import cHosterGui
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.inputParameterHandler import \
    cInputParameterHandler
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.outputParameterHandler import \
    cOutputParameterHandler
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.handler.requestHandler import \
    cRequestHandler
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.multihost import (cVidNet,
                                                                     cVidPro,
                                                                     cVidVip)
from Plugins.Extensions.IPTVPlayer.libs.matrix.lib.parser import cParser

UA = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/127.0.0.0 Safari/537.36 Edg/127.0.0.0'

SITE_IDENTIFIER = 'vidplay'
SITE_NAME = 'VidPlay'
SITE_DESC = 'english vod'

URL_MAIN = siteManager().getUrlMain(SITE_IDENTIFIER)

MOVIE_EN = (f'{URL_MAIN}/movies/year', 'showMovies')
KID_MOVIES = (f'{URL_MAIN}/genres/watch-animation-movies-online-free-release/1', 'showMovies')
MOVIE_TOP = (f'{URL_MAIN}/movies/star-rating/', 'showMovies')
MOVIE_POP = (f'{URL_MAIN}/movies/popular/', 'showMovies')
MOVIE_GENRES = (f'{URL_MAIN}/movies', 'moviesGenres')
SERIE_EN = (f'{URL_MAIN}/tv-shows', 'showSeries')
ANIM_NEWS = (f'{URL_MAIN}/tv-tags/animation', 'showSeries')
SERIE_GENRES = (f'{URL_MAIN}/tv-shows', 'seriesGenres')

DOC_NEWS = (f'{URL_MAIN}/genres/watch-documentary-movies-online-free-release/1', 'showMovies')
DOC_SERIES = (f'{URL_MAIN}/tv-tags/documentary', 'showSeries')

URL_SEARCH_MOVIES = (f'{URL_MAIN}/index.php?menu=search&query=', 'showMovies')
URL_SEARCH_SERIES = (f'{URL_MAIN}/index.php?menu=search&query=', 'showSeries')
FUNCTION_SEARCH = 'showMovies'


def load():
    oGui = cGui()
    addons = addon()
    oOutputParameterHandler = cOutputParameterHandler()

    oGui.addText(SITE_IDENTIFIER, f'[COLOR olive]-----●★| {addons.VSlang(30076)} |★●-----[/COLOR]')

    oOutputParameterHandler.addParameter('siteUrl', 'http://venom/')
    oGui.addDir(SITE_IDENTIFIER, 'showSearch', addons.VSlang(30078), 'search.png', oOutputParameterHandler)

    oOutputParameterHandler.addParameter('siteUrl', 'http://venom/')
    oGui.addDir(SITE_IDENTIFIER, 'showSeriesSearch', addons.VSlang(30079), 'search.png', oOutputParameterHandler)

    oGui.addText(SITE_IDENTIFIER, f'[COLOR olive]-----●★| {addons.VSlang(30120)} |★●-----[/COLOR]')

    oOutputParameterHandler.addParameter('siteUrl', MOVIE_EN[0])
    oGui.addDir(SITE_IDENTIFIER, 'showMovies', 'أفلام أجنبية', 'agnab.png', oOutputParameterHandler)

    oOutputParameterHandler.addParameter('siteUrl', KID_MOVIES[0])
    oGui.addDir(SITE_IDENTIFIER, 'showMovies', 'أفلام انيميشن', 'anim.png', oOutputParameterHandler)

    oOutputParameterHandler.addParameter('siteUrl', MOVIE_POP[0])
    oGui.addDir(SITE_IDENTIFIER, 'showMovies', 'الأفلام الرائجة', 'film.png', oOutputParameterHandler)

    oOutputParameterHandler.addParameter('siteUrl', DOC_NEWS[0])
    oGui.addDir(SITE_IDENTIFIER, 'showMovies', 'أفلام وثائقية', 'doc.png', oOutputParameterHandler)

    oOutputParameterHandler.addParameter('siteUrl', MOVIE_GENRES[0])
    oGui.addDir(SITE_IDENTIFIER, MOVIE_GENRES[1], 'الأفلام (الأنواع)', 'film.png', oOutputParameterHandler)

    oGui.addText(SITE_IDENTIFIER, f'[COLOR olive]-----●★| {addons.VSlang(30121)} |★●-----[/COLOR]')

    oOutputParameterHandler.addParameter('siteUrl', SERIE_EN[0])
    oGui.addDir(SITE_IDENTIFIER, 'showSeries', 'مسلسلات أجنبية', 'agnab.png', oOutputParameterHandler)

    oOutputParameterHandler.addParameter('siteUrl', ANIM_NEWS[0])
    oGui.addDir(SITE_IDENTIFIER, 'showSeries', 'مسلسلات انيميشن', 'anime.png', oOutputParameterHandler)

    oOutputParameterHandler.addParameter('siteUrl', f'{URL_MAIN}/tv-shows/popular')
    oGui.addDir(SITE_IDENTIFIER, 'showSeries', 'المسلسلات الرائجة', 'mslsl.png', oOutputParameterHandler)

    oOutputParameterHandler.addParameter('siteUrl', DOC_SERIES[0])
    oGui.addDir(SITE_IDENTIFIER, 'showSeries', 'مسلسلات وثائقية', 'doc.png', oOutputParameterHandler)

    oOutputParameterHandler.addParameter('siteUrl', SERIE_GENRES[0])
    oGui.addDir(SITE_IDENTIFIER, SERIE_GENRES[1], 'المسلسلات (الأنواع)', 'mslsl.png', oOutputParameterHandler)

    oGui.setEndOfDirectory()


def showSearch():
    oGui = cGui()
    if (sSearchText := oGui.showKeyBoard()):
        sUrl = f'{URL_MAIN}/index.php?menu=search&query={sSearchText}'
        showMovies(sUrl)
        oGui.setEndOfDirectory()
        return


def showSeriesSearch():
    oGui = cGui()
    if (sSearchText := oGui.showKeyBoard()):
        sUrl = f'{URL_MAIN}/index.php?menu=search&query={sSearchText}'
        showSeries(sUrl)
        oGui.setEndOfDirectory()
        return


def seriesGenres():
    oGui = cGui()

    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')

    oParser = cParser()
    oRequestHandler = cRequestHandler(sUrl)
    sHtmlContent = oRequestHandler.request()

    sPattern = '<option value="([^<]+)">([^<]+)</option>'
    aResult = oParser.parse(sHtmlContent, sPattern)
    if aResult[0]:
        oOutputParameterHandler = cOutputParameterHandler()
        for aEntry in aResult[1]:

            sTitle = aEntry[1]
            siteUrl = f'{URL_MAIN}{aEntry[0]}'

            oOutputParameterHandler = cOutputParameterHandler()
            oOutputParameterHandler.addParameter('siteUrl', siteUrl)
            oOutputParameterHandler.addParameter('sMovieTitle', sTitle)

            oGui.addMisc(SITE_IDENTIFIER, 'showSeries', sTitle, 'film.png', '', '', oOutputParameterHandler)

    oGui.setEndOfDirectory()


def moviesGenres():
    oGui = cGui()

    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')

    oParser = cParser()
    oRequestHandler = cRequestHandler(sUrl)
    sHtmlContent = oRequestHandler.request()

    sPattern = '<option value="([^<]+)">([^<]+)</option>'
    aResult = oParser.parse(sHtmlContent, sPattern)
    if aResult[0]:
        oOutputParameterHandler = cOutputParameterHandler()
        for aEntry in aResult[1]:

            sTitle = aEntry[1]
            siteUrl = f'{URL_MAIN}{aEntry[0]}'

            oOutputParameterHandler = cOutputParameterHandler()
            oOutputParameterHandler.addParameter('siteUrl', siteUrl)
            oOutputParameterHandler.addParameter('sMovieTitle', sTitle)

            oGui.addMisc(SITE_IDENTIFIER, 'showMovies', sTitle, 'film.png', '', '', oOutputParameterHandler)

    oGui.setEndOfDirectory()


def showMovies(sSearch=''):
    oGui = cGui()
    if sSearch:
        sUrl = sSearch
        sPattern = '<figure class="figured">\s*<a href="([^"]+)".+?src="([^"]+)".+?<div class="title">(.+?)</div>.+?<div class="year".+?>(.+?)</div>'

    else:
        oInputParameterHandler = cInputParameterHandler()
        sUrl = oInputParameterHandler.getValue('siteUrl')
        sPattern = '<figure class="figured">\s*<a href="([^"]+)".+?data-src="([^"]+)".+?<div class="title">(.+?)</div>.+?<div class="year".+?>(.+?)</div>'

    oParser = cParser()
    oRequestHandler = cRequestHandler(sUrl)
    sHtmlContent = oRequestHandler.request()

    aResult = oParser.parse(sHtmlContent, sPattern)
    if aResult[0]:
        oOutputParameterHandler = cOutputParameterHandler()
        for aEntry in aResult[1]:
            if "watchseries/" in aEntry[0]:
                continue

            sTitle = f'{aEntry[2]} ({aEntry[3]})'
            siteUrl = f'{URL_MAIN}{aEntry[0]}'
            sThumb = aEntry[1]
            sDesc = ''
            sYear = aEntry[3]

            oOutputParameterHandler.addParameter('siteUrl', siteUrl)
            oOutputParameterHandler.addParameter('sMovieTitle', sTitle)
            oOutputParameterHandler.addParameter('sThumb', sThumb)
            oOutputParameterHandler.addParameter('sYear', sYear)
            oOutputParameterHandler.addParameter('sDesc', sDesc)
            oGui.addTV(SITE_IDENTIFIER, 'showLinks', sTitle, '', sThumb, sDesc, oOutputParameterHandler)

        if (sNextPage := __checkForNextPage(sHtmlContent)):
            oOutputParameterHandler = cOutputParameterHandler()
            oOutputParameterHandler.addParameter('siteUrl', sNextPage)
            oGui.addDir(SITE_IDENTIFIER, 'showMovies', '[COLOR teal]Next >>>[/COLOR]', 'next.png', oOutputParameterHandler)

    if not sSearch:
        oGui.setEndOfDirectory()


def showSeries(sSearch=''):
    oGui = cGui()
    if sSearch:
        sUrl = sSearch
        sPattern = '<figure class="figured">\s*<a href="([^"]+)".+?src="([^"]+)".+?<div class="title">(.+?)</div>.+?<div class="year".+?>(.+?)</div>'

    else:
        oInputParameterHandler = cInputParameterHandler()
        sUrl = oInputParameterHandler.getValue('siteUrl')
        sPattern = '<figure class="figured">\s*<a href="([^"]+)".+?data-src="([^"]+)".+?<div class="title">(.+?)</div>.+?<div class="year".+?>(.+?)</div>'

    oParser = cParser()
    oRequestHandler = cRequestHandler(sUrl)
    sHtmlContent = oRequestHandler.request()

    aResult = oParser.parse(sHtmlContent, sPattern)
    if aResult[0]:
        oOutputParameterHandler = cOutputParameterHandler()
        for aEntry in aResult[1]:
            if "movie/" in aEntry[0]:
                continue

            sTitle = aEntry[2]
            siteUrl = f'{URL_MAIN}{aEntry[0]}'
            sThumb = aEntry[1]
            sDesc = ''
            sYear = aEntry[3]

            oOutputParameterHandler.addParameter('siteUrl', siteUrl)
            oOutputParameterHandler.addParameter('sMovieTitle', sTitle)
            oOutputParameterHandler.addParameter('sThumb', sThumb)
            oOutputParameterHandler.addParameter('sYear', sYear)
            oOutputParameterHandler.addParameter('sDesc', sDesc)

            oGui.addTV(SITE_IDENTIFIER, 'showSeasons', sTitle, '', sThumb, sDesc, oOutputParameterHandler)

        if (sNextPage := __checkForNextPage(sHtmlContent)):
            oOutputParameterHandler = cOutputParameterHandler()
            oOutputParameterHandler.addParameter('siteUrl', sNextPage)
            oGui.addDir(SITE_IDENTIFIER, 'showSeries', '[COLOR teal]Next >>>[/COLOR]', 'next.png', oOutputParameterHandler)

    if not sSearch:
        oGui.setEndOfDirectory()


def showSeasons():
    oGui = cGui()

    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')
    sMovieTitle = oInputParameterHandler.getValue('sMovieTitle')
    sThumb = oInputParameterHandler.getValue('sThumb')

    oParser = cParser()
    oRequestHandler = cRequestHandler(sUrl)
    sHtmlContent = oRequestHandler.request()

    sPattern = '<div class="seasonHeader".+?>Season(.+?)</b>.+?<div class="episodeList"(.+?)</div>'
    aResult = oParser.parse(sHtmlContent, sPattern)
    if aResult[0]:
        oOutputParameterHandler = cOutputParameterHandler()
        for aEntry in aResult[1]:
            sId = aEntry[0]
            sHtml = aEntry[1]

            sTitle = f"{sMovieTitle} S{sId}"
            sDesc = ''

            oOutputParameterHandler.addParameter('siteUrl', sUrl)
            oOutputParameterHandler.addParameter('sHtml', sHtml)
            oOutputParameterHandler.addParameter('sMovieTitle', sTitle)
            oOutputParameterHandler.addParameter('sThumb', sThumb)
            oGui.addSeason(SITE_IDENTIFIER, 'showEps', sTitle, '', sThumb, sDesc, oOutputParameterHandler)

    oGui.setEndOfDirectory()


def showEps():
    oGui = cGui()

    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')
    sMovieTitle = oInputParameterHandler.getValue('sMovieTitle')
    sThumb = oInputParameterHandler.getValue('sThumb')
    sHtmlContent = oInputParameterHandler.getValue('sHtml')

    oParser = cParser()
    sPattern = 'href="([^"]+)">(.+?)<span'
    aResult = oParser.parse(sHtmlContent, sPattern)
    if aResult[1]:
        oOutputParameterHandler = cOutputParameterHandler()
        for aEntry in aResult[1]:

            sEp = aEntry[1].replace('Episode ', '').strip()
            siteUrl = f'{URL_MAIN}/{aEntry[0]}'
            sTitle = f"{sMovieTitle} E{sEp}"
            sDesc = ""

            oOutputParameterHandler.addParameter('siteUrl', siteUrl)
            oOutputParameterHandler.addParameter('sMovieTitle', sTitle)
            oOutputParameterHandler.addParameter('sThumb', sThumb)
            oGui.addEpisode(SITE_IDENTIFIER, 'showSeriesLinks', sTitle, sThumb, sThumb, sDesc, oOutputParameterHandler)

    oGui.setEndOfDirectory()


def showLinks(oInputParameterHandler=False):
    oGui = cGui()

    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')
    sMovieTitle = oInputParameterHandler.getValue('sMovieTitle')
    sThumb = oInputParameterHandler.getValue('sThumb')

    oParser = cParser()
    oRequestHandler = cRequestHandler(sUrl)
    sHtmlContent = oRequestHandler.request()

    url_pattern = r"\$.get\('(.+?)',"
    embed_pattern = r'"embed":\s*"(.+?)"'

    url_matches = re.findall(url_pattern, sHtmlContent)
    embed_matches = re.findall(embed_pattern, sHtmlContent)

    url_embed_pairs = zip(url_matches, embed_matches)
    sLinks = list(url_embed_pairs)

    for aEntry in sLinks:
        nUrl = f'{URL_MAIN}{aEntry[0]}?embed={aEntry[1]}'

        oRequestHandler = cRequestHandler(nUrl)
        oRequestHandler.addHeaderEntry('Referer', sUrl)
        oRequestHandler.addHeaderEntry('X-Requested-With', 'XMLHttpRequest')
        oRequestHandler.addHeaderEntry('User-Agent', UA)
        sHtmlContent = oRequestHandler.request()

        sPattern = '<iframe src="([^"]+)'
        aResult = oParser.parse(sHtmlContent, sPattern)
        if aResult[0]:
            oOutputParameterHandler = cOutputParameterHandler()
            iFrame = aResult[1][0]
            sHost = urlparse(iFrame).netloc

            sTitle = f'{sMovieTitle} ({sHost})'
            oOutputParameterHandler.addParameter('sHosterUrl', iFrame)
            oOutputParameterHandler.addParameter('siteUrl', sUrl)
            oOutputParameterHandler.addParameter('sMovieTitle', sMovieTitle)
            oOutputParameterHandler.addParameter('sThumb', sThumb)

            oGui.addLink(SITE_IDENTIFIER, 'showHosters', sTitle, sThumb, '', oOutputParameterHandler)

    oGui.setEndOfDirectory()


def showSeriesLinks(oInputParameterHandler=False):
    oGui = cGui()

    oInputParameterHandler = cInputParameterHandler()
    sUrl = oInputParameterHandler.getValue('siteUrl')
    sMovieTitle = oInputParameterHandler.getValue('sMovieTitle')
    sThumb = oInputParameterHandler.getValue('sThumb')

    oParser = cParser()
    oRequestHandler = cRequestHandler(sUrl)
    sHtmlContent = oRequestHandler.request()

    url_pattern = r"\$.get\('(.+?)',"
    embed_pattern = r'"embed":\s*"(.+?)"'
    season_pattern = r'"season":\s*"(.+?)"'
    episode_pattern = r'"episode":\s*"(.+?)"'

    url_matches = re.findall(url_pattern, sHtmlContent)
    embed_matches = re.findall(embed_pattern, sHtmlContent)
    season_matches = re.findall(season_pattern, sHtmlContent)
    episode_matches = re.findall(episode_pattern, sHtmlContent)

    url_embed_pairs = zip(url_matches, embed_matches, season_matches, episode_matches)
    sLinks = list(url_embed_pairs)

    for aEntry in sLinks:
        nUrl = f'{URL_MAIN}{aEntry[0]}?embed={aEntry[1]}&season={season_matches}&episode={episode_matches}'

        oRequestHandler = cRequestHandler(nUrl)
        oRequestHandler.addHeaderEntry('Referer', sUrl)
        oRequestHandler.addHeaderEntry('X-Requested-With', 'XMLHttpRequest')
        oRequestHandler.addHeaderEntry('User-Agent', UA)
        sHtmlContent = oRequestHandler.request()

        sPattern = '<iframe src="([^"]+)'
        aResult = oParser.parse(sHtmlContent, sPattern)
        if aResult[0]:
            oOutputParameterHandler = cOutputParameterHandler()
            iFrame = aResult[1][0]
            if '[' in iFrame:
                parts = iFrame.replace('[', '').replace(']', '').split('/')
                base_url = '/'.join(parts[:-2])
                season = parts[-2][1]
                episode = parts[-1][1]
                iFrame = f"{base_url}/{season}/{episode}"
            if '.vip' in iFrame:
                iFrame = f'{iFrame}&server=1&switch=off&autoplay=true'

            sHost = urlparse(iFrame).netloc

            sTitle = f'{sMovieTitle} ({sHost})'
            oOutputParameterHandler.addParameter('sHosterUrl', iFrame)
            oOutputParameterHandler.addParameter('siteUrl', sUrl)
            oOutputParameterHandler.addParameter('sSeason', season)
            oOutputParameterHandler.addParameter('sEpisode', episode)
            oOutputParameterHandler.addParameter('sMovieTitle', sMovieTitle)
            oOutputParameterHandler.addParameter('sThumb', sThumb)

            oGui.addLink(SITE_IDENTIFIER, 'showHosters', sTitle, sThumb, '', oOutputParameterHandler)

    oGui.setEndOfDirectory()


def showHosters():
    oGui = cGui()

    oInputParameterHandler = cInputParameterHandler()
    sMovieTitle = oInputParameterHandler.getValue('sMovieTitle')
    sUrl = oInputParameterHandler.getValue('sHosterUrl')
    sThumb = oInputParameterHandler.getValue('sThumb')
    sSeason = oInputParameterHandler.getValue('sSeason')
    sEpisode = oInputParameterHandler.getValue('sEpisode')

    if '.net' in sUrl:
        try:
            data = cVidNet().extract(sUrl)

            sHosterUrl = data['source']
            subtitles = data['subtitles']
            referer = data['referer']

            sHosterUrl = f'{sHosterUrl}|Referer={referer}?sub.info={subtitles}'
            if (oHoster := cHosterGui().getHoster('vidsrcstream')):
                oHoster.setDisplayName(sMovieTitle)
                oHoster.setFileName(sMovieTitle)
                cHosterGui().showHoster(oGui, oHoster, sHosterUrl, sThumb)

        except:
            oGui.addText(SITE_IDENTIFIER, '[COLOR red]فشل الاتصال بالموقع الاول، حاول مرة أخرى[/COLOR]')

    if '.xyz' in sUrl or '.vip' in sUrl:
        try:
            sLink = cVidVip().extract(sUrl)
            for item in sLink:
                sHosterUrl = item.split(',')[0].split('url=')[1]
                sQual = item.split(',')[1].split('qual=')[1]

                sDisplayTitle = f'{sMovieTitle} ({sQual})'
                if (oHoster := cHosterGui().getHoster('lien_direct')):
                    oHoster.setDisplayName(sDisplayTitle)
                    oHoster.setFileName(sMovieTitle)
                    cHosterGui().showHoster(oGui, oHoster, sHosterUrl, sThumb)

        except:
            oGui.addText(SITE_IDENTIFIER, '[COLOR red]فشل الاتصال بالموقع الاول، حاول مرة أخرى[/COLOR]')

    if '.pro' in sUrl:
        try:
            sID = sUrl.split("/")[5]
            testURL = base64.b64decode('PURJdHNldXFlcj9oY3RlZmRuZWtjYWIvaXBhL2V2aWwubWFlcnRzZXZpci8vOnNwdHRo').decode('utf-8')[::-1]
            aLink = f'{testURL}movieVideoProvider&id={sID}&service=vidcloud'
            if '/tv/' in sUrl:
                aLink = f'{testURL}tvVideoProvider&id={sID}&service=vidcloud&season={sSeason}&episode={sEpisode}'
            oRequestHandler = cRequestHandler(aLink)
            oRequestHandler.addHeaderEntry('Referer', testURL)
            oRequestHandler.addHeaderEntry('User-Agent', UA)
            sHtmlContent = oRequestHandler.request(jsonDecode=True)

            sources = sHtmlContent['data']['sources']

            sSub = ''
            try:
                captions = sHtmlContent['data']['captions']
                arabic_subtitles = [caption['file'] for caption in captions if 'sudan' in caption['label']]
                if arabic_subtitles:
                    sSub = arabic_subtitles
                else:
                    sSub = [caption['file'] for caption in captions if 'English' in caption['label']]
            except:
                VSlog('failed to get subs')

            for source in sources:
                sHosterUrl = source['url']
                sQual = source['quality']

                sDisplayTitle = f'{sMovieTitle} ({sQual})'
                sHosterUrl = f'{sHosterUrl}|Referer={testURL.split("api/")[0]}?sub.info={sSub}'
                if (oHoster := cHosterGui().getHoster('lien_direct')):
                    oHoster.setDisplayName(sDisplayTitle)
                    oHoster.setFileName(sMovieTitle)
                    cHosterGui().showHoster(oGui, oHoster, sHosterUrl, sThumb)

        except:
            VSlog('فشل الاتصال بالموقع التجريبي')

        try:
            sHosterUrl = cVidPro().extract(sUrl)

            sDisplayTitle = sMovieTitle
            if (oHoster := cHosterGui().getHoster('vidsrcstream')):
                oHoster.setDisplayName(sDisplayTitle)
                oHoster.setFileName(sMovieTitle)
                cHosterGui().showHoster(oGui, oHoster, sHosterUrl, sThumb)

        except:
            oGui.addText(SITE_IDENTIFIER, '[COLOR red]فشل الاتصال بالموقع الاول، حاول مرة أخرى[/COLOR]')

    oGui.setEndOfDirectory()


def __checkForNextPage(sHtmlContent):
    oParser = cParser()
    sPattern = '<li><a href="([^"]+)">Next'
    aResult = oParser.parse(sHtmlContent, sPattern)
    if aResult[0]:
        return aResult[1][0]

    return False
